/**
 * Get ID Post
 *
 * @param {String}  pageID
 * @param {String}  accessToken
 * @param {String}  inputUrl
 * @param {String}  callback
 * @return {String} Array UID
 */

const request = require("request")
const config = require("../config/config")

module.exports = get;

var data = []

function get(idPage, accessToken, inputUrl, callback){
    let node = "/feed?fields=id,message&limit=100&order(reverse_chronological)"
    let url

    if(inputUrl == undefined)
        url = config.graphFacebook+ idPage+ node+ "&access_token="+ accessToken
    else
        url = inputUrl

    request.get(url, (err, body, res)=>{
        if(err)
            return callback(err)
        
        let jsonRes = JSON.parse(res)

        if(jsonRes.data)
            jsonRes.data.map(value => data.push(value))
        
        if(jsonRes.error)
        {
            switch(jsonRes.error.code)
            {
                case 1:
                case 2:
                case 4:
                case 17:
                case 341:
                case 368:
                {
                    setTimeout(()=>{
                        get(null, null, url, callback)
                    },10000)
                }
                default:
                    return callback(jsonRes.error, undefined)
            }
        }

        if(jsonRes.paging && jsonRes.paging.next)
            get(null, null, jsonRes.paging.next, callback)
        else
            return callback(err, data)
    })
}
